(* On initialise le générateur de nombres aléatoire avec une graine
   fixe. Cela permet que les caractères tirés « au hasard » soient
   toujours les même, ce qui facilite le débuggage.
   Une fois le code correct, on peut remplacer cette ligne par:
   let () = Random.self_init ()
   pour obtenir une grille différente à chaque exécution.
*)

let () = Random.init 17

(* La fonction [make_grid n]
   Doit créer un tableau de taille n 
   de chaînes de caractères aléatoires de taille n,
   où chaque caractère est compris entre 'A' et 'Z'   
*)

let make_grid n =
  failwith "todo"

(* La fonction [print_grid grid]*)
let print_grid g =
  failwith "todo"

(* La fonction load_dico charge le fichier f
   et renvoie un trie.
   Ce dernier étant utilisé comme un ensemble, on peut
   stocker une valeur bidon pour chaque clé, par
   exemple la valeur ()
   Attention, les fonctions sur les trie sont
   dans le module Trie, il faut donc utiliser ce nom de module,
   par exemple [Trie.add]
*)
let load_dico f =
  failwith "todo"

(* La fonction [print_word l] prend une liste de caractères inversée,
   la renverse et crée une chaine avec.
   CF la fonction rev_implode du TP précédent.
*)
let print_word l = 
  failwith "todo"

module Pos =
struct
  type t = (int * int)
  let compare p1 p2 = compare p1 p2
end

module PosSet = Set.Make(Pos)


(* La fonction next_positions renvoie la liste des couples
   de position voisines valide pour la grille données et qui
   n'ont pas déjà été visitées.

   Pour une case "centrale" il s'agit des 8 cases autour de la
   case donnée. Mais pour une case dans un coin ou sur les bords,
   il y a moins de voisins.
*)

let next_positions grid row col visited =
  failwith "todo"


(*
  grid : la grille
  row, col : la case courante
  l : une liste de couples (char, trie)
  word: la liste inversée des lettres, la tête
  de la liste est grid.(row).[col]

  *)

(* La fonction récursive :

*)

let rec solve_list  grid row col l word visited =
  let c = grid.(row).[col] in
  match List.assoc_opt c l with
    None -> ()   (* pas de caractère trouvé *)
  | Some t -> (* un caractère trouvé, on l'ajoute à la liste et on visite le trie associé *)
    solve_node grid row col t (c::word) visited

and solve_node grid row col t word visited =
  (* on est arrivé sur le la case row col, son caractère
     est en tete de word
  *)
  let Trie.Node(o, l) = t in
  let () = match o with
      None -> () (* on ne fait rien *)
    | Some _ -> print_word word  (* on est sur un nœud terminal *)
  in
  let visited' = PosSet.add (row, col) visited in (* on ajoute cette case à l'ensemle des visités *)
  let next = next_positions grid row col visited' in (* on demande la liste des cases voisines *)
  List.iter (fun (row', col') -> 
      solve_list grid row' col' l word visited'  (* pour chaque case voisine, on cherche dans la liste
                                                    du trie s'il y a un sous-trie avec le caractère de la case*)
    ) next


(* *)
let main () =
  let dico = load_dico "french_simple.txt" in
  let n = 5 in
  let grid = make_grid n in
  let () = print_grid grid in
  let Trie.Node (_, l) = dico in (* on extrait la liste des premières lettres*)
  for i = 0 to n - 1 do
    for j = 0 to n - 2 do
      solve_list grid i j l [] PosSet.empty
    done
  done
